diff --git a/tools/gcc/size_overflow_plugin/remove_unnecessary_dup.c b/tools/gcc/size_overflow_plugin/remove_unnecessary_dup.c
new file mode 100644
index 0000000..5622b51
--- /dev/null
+++ b/tools/gcc/size_overflow_plugin/remove_unnecessary_dup.c
@@ -0,0 +1,137 @@
+/*
+ * Copyright 2011-2015 by Emese Revfy <re.emese@gmail.com>
+ * Licensed under the GPL v2, or (at your option) v3
+ *
+ * Homepage:
+ * https://github.com/ephox-gcc-plugins/size_overflow
+ *
+ * Documentation:
+ * http://forums.grsecurity.net/viewtopic.php?f=7&t=3043
+ *
+ * This plugin recomputes expressions of function arguments marked by a size_overflow attribute
+ * with double integer precision (DImode/TImode for 32/64 bit integer types).
+ * The recomputed argument is checked against TYPE_MAX and an event is logged on overflow and the triggering process is killed.
+ *
+ * Usage:
+ * $ make
+ * $ make run
+ */
+
+#include "size_overflow.h"
+
+bool skip_expr_on_double_type(const gassign *stmt)
+{
+	enum tree_code code = gimple_assign_rhs_code(stmt);
+
+	switch (code) {
+	case RSHIFT_EXPR:
+	case TRUNC_DIV_EXPR:
+	case CEIL_DIV_EXPR:
+	case FLOOR_DIV_EXPR:
+	case ROUND_DIV_EXPR:
+	case EXACT_DIV_EXPR:
+	case RDIV_EXPR:
+	case TRUNC_MOD_EXPR:
+	case CEIL_MOD_EXPR:
+	case FLOOR_MOD_EXPR:
+	case ROUND_MOD_EXPR:
+		return true;
+	default:
+		return false;
+	}
+}
+
+void create_up_and_down_cast(struct visited *visited, gassign *use_stmt, tree orig_type, tree rhs)
+{
+	const_tree orig_rhs1;
+	tree down_lhs, new_lhs, dup_type = TREE_TYPE(rhs);
+	const_gimple down_cast, up_cast;
+	gimple_stmt_iterator gsi = gsi_for_stmt(use_stmt);
+
+	down_cast = build_cast_stmt(visited, orig_type, rhs, CREATE_NEW_VAR, &gsi, BEFORE_STMT, false);
+	down_lhs = get_lhs(down_cast);
+
+	gsi = gsi_for_stmt(use_stmt);
+	up_cast = build_cast_stmt(visited, dup_type, down_lhs, CREATE_NEW_VAR, &gsi, BEFORE_STMT, false);
+	new_lhs = get_lhs(up_cast);
+
+	orig_rhs1 = gimple_assign_rhs1(use_stmt);
+	if (operand_equal_p(orig_rhs1, rhs, 0))
+		gimple_assign_set_rhs1(use_stmt, new_lhs);
+	else
+		gimple_assign_set_rhs2(use_stmt, new_lhs);
+	update_stmt(use_stmt);
+
+	pointer_set_insert(visited->my_stmts, up_cast);
+	pointer_set_insert(visited->my_stmts, down_cast);
+	pointer_set_insert(visited->skip_expr_casts, up_cast);
+	pointer_set_insert(visited->skip_expr_casts, down_cast);
+}
+
+static tree get_proper_unsigned_half_type(const_tree node)
+{
+	tree new_type, type;
+
+	gcc_assert(is_size_overflow_type(node));
+
+	type = TREE_TYPE(node);
+	switch (TYPE_MODE(type)) {
+	case HImode:
+		new_type = unsigned_intQI_type_node;
+		break;
+	case SImode:
+		new_type = unsigned_intHI_type_node;
+		break;
+	case DImode:
+		new_type = unsigned_intSI_type_node;
+		break;
+	case TImode:
+		new_type = unsigned_intDI_type_node;
+		break;
+	default:
+		gcc_unreachable();
+	}
+
+	if (TYPE_QUALS(type) != 0)
+		return build_qualified_type(new_type, TYPE_QUALS(type));
+	return new_type;
+}
+
+static void insert_cast_rhs(struct visited *visited, gassign *stmt, tree rhs)
+{
+	tree type;
+
+	if (rhs == NULL_TREE)
+		return;
+	if (!is_size_overflow_type(rhs))
+		return;
+
+	type = get_proper_unsigned_half_type(rhs);
+	if (is_gimple_constant(rhs))
+		return;
+	create_up_and_down_cast(visited, stmt, type, rhs);
+}
+
+static void insert_cast(struct visited *visited, gassign *stmt, tree rhs)
+{
+	if (LONG_TYPE_SIZE == GET_MODE_BITSIZE(SImode) && !is_size_overflow_type(rhs))
+		return;
+	gcc_assert(is_size_overflow_type(rhs));
+	insert_cast_rhs(visited, stmt, rhs);
+}
+
+void insert_cast_expr(struct visited *visited, gassign *stmt, enum intentional_overflow_type type)
+{
+	tree rhs1, rhs2;
+
+	if (type == NO_INTENTIONAL_OVERFLOW || type == RHS1_INTENTIONAL_OVERFLOW) {
+		rhs1 = gimple_assign_rhs1(stmt);
+		insert_cast(visited, stmt, rhs1);
+	}
+
+	if (type == NO_INTENTIONAL_OVERFLOW || type == RHS2_INTENTIONAL_OVERFLOW) {
+		rhs2 = gimple_assign_rhs2(stmt);
+		insert_cast(visited, stmt, rhs2);
+	}
+}
+
diff --git a/tools/gcc/size_overflow_plugin/size_overflow.h b/tools/gcc/size_overflow_plugin/size_overflow.h
new file mode 100644
index 0000000..b7f66f7
--- /dev/null
+++ b/tools/gcc/size_overflow_plugin/size_overflow.h
@@ -0,0 +1,329 @@
+#ifndef SIZE_OVERFLOW_H
+#define SIZE_OVERFLOW_H
+
+#define CREATE_NEW_VAR NULL_TREE
+#define MAX_PARAM 31
+#define CANNOT_FIND_ARG 32
+#define NONE_ARGNUM 32
+
+#define BEFORE_STMT true
+#define AFTER_STMT false
+
+#define TURN_OFF_ASM_STR "# size_overflow MARK_TURN_OFF "
+#define YES_ASM_STR "# size_overflow MARK_YES "
+#define END_INTENTIONAL_ASM_STR "# size_overflow MARK_END_INTENTIONAL "
+#define SO_ASM_STR "# size_overflow "
+#define OK_ASM_STR "# size_overflow MARK_NO"
+
+#define FUNCTION_PTR_P(node) \
+	(TREE_CODE(TREE_TYPE(node)) == POINTER_TYPE && (TREE_CODE(TREE_TYPE(TREE_TYPE(node))) == FUNCTION_TYPE || TREE_CODE(TREE_TYPE(TREE_TYPE(node))) == METHOD_TYPE))
+
+#define CODES_LIMIT 32
+
+#define GLOBAL_NIFN_LEN 65536
+#define NO_HASH 65537
+
+#define SIZE_OVERFLOW true
+#define DISABLE_SIZE_OVERFLOW false
+
+#include "gcc-common.h"
+
+#include <string.h>
+#include <limits.h>
+
+enum intentional_mark {
+	MARK_NO, MARK_YES, MARK_END_INTENTIONAL, MARK_TURN_OFF
+};
+
+enum intentional_overflow_type {
+	NO_INTENTIONAL_OVERFLOW, RHS1_INTENTIONAL_OVERFLOW, RHS2_INTENTIONAL_OVERFLOW
+};
+
+enum size_overflow_mark {
+	NO_SO_MARK, YES_SO_MARK, ASM_STMT_SO_MARK
+};
+
+struct decl_hash {
+	size_t tree_codes_len;
+	unsigned char tree_codes[CODES_LIMIT];
+	const_tree decl;
+	const char *context;
+	unsigned int hash;
+	const char *fn_name;
+};
+
+struct next_interesting_function;
+typedef struct next_interesting_function *  next_interesting_function_t;
+
+struct interesting_stmts;
+typedef struct interesting_stmts * interesting_stmts_t;
+
+// Store data associated with the next_interesting_function_t entry
+struct fn_raw_data
+{
+	const char *decl_str;
+	tree decl;
+	const char *context;
+	unsigned int hash;
+	unsigned int num;
+	enum size_overflow_mark marked;
+};
+
+#if BUILDING_GCC_VERSION <= 4007
+DEF_VEC_P(next_interesting_function_t);
+DEF_VEC_ALLOC_P(next_interesting_function_t, heap);
+#endif
+
+#if BUILDING_GCC_VERSION >= 5000
+typedef struct hash_set<const_gimple> gimple_set;
+
+static inline bool pointer_set_insert(gimple_set *visited, const_gimple stmt)
+{
+	return visited->add(stmt);
+}
+
+static inline bool pointer_set_contains(gimple_set *visited, const_gimple stmt)
+{
+	return visited->contains(stmt);
+}
+
+static inline gimple_set* pointer_set_create(void)
+{
+	return new hash_set<const_gimple>;
+}
+
+static inline void pointer_set_destroy(gimple_set *visited)
+{
+	delete visited;
+}
+
+typedef struct hash_set<next_interesting_function_t> next_interesting_function_set;
+
+static inline bool pointer_set_insert(next_interesting_function_set *visited, next_interesting_function_t node)
+{
+	return visited->add(node);
+}
+
+static inline bool pointer_set_contains(next_interesting_function_set *visited, next_interesting_function_t node)
+{
+	return visited->contains(node);
+}
+
+static inline next_interesting_function_set *next_interesting_function_pointer_set_create(void)
+{
+	return new hash_set<next_interesting_function_t>;
+}
+
+static inline void pointer_set_destroy(next_interesting_function_set *visited)
+{
+	delete visited;
+}
+#else
+typedef struct pointer_set_t gimple_set;
+typedef struct pointer_set_t next_interesting_function_set;
+
+static inline next_interesting_function_set *next_interesting_function_pointer_set_create(void)
+{
+	return pointer_set_create();
+}
+#endif
+
+struct visited {
+	gimple_set *stmts;
+	gimple_set *my_stmts;
+	gimple_set *skip_expr_casts;
+	gimple_set *no_cast_check;
+};
+
+/*
+ *  * children: callers with data flow into the integer parameter of decl
+ *  * decl_name: name of the function or the field
+ *  * context: the containing type name for a function pointer (or "fielddecl" if the type has no name), otherwise either "vardecl" or "fndecl"
+ *  * hash: hash num of the function
+ *  * num: parameter number (1-31) or return value (0)
+ *  * marked: determines whether to duplicate stmts and/or look for missing hashtable entries
+ *  * orig_next_node: pointer to the originally cloned function
+ */
+
+struct next_interesting_function {
+	next_interesting_function_t next;
+#if BUILDING_GCC_VERSION <= 4007
+	VEC(next_interesting_function_t, heap) *children;
+#else
+	vec<next_interesting_function_t, va_heap, vl_embed> *children;
+#endif
+	const char *decl_name;
+	const char *context;
+	unsigned int hash;
+	unsigned int num;
+	enum size_overflow_mark marked;
+	next_interesting_function_t orig_next_node;
+};
+
+// size_overflow_plugin.c
+extern tree report_size_overflow_decl;
+extern tree size_overflow_type_HI;
+extern tree size_overflow_type_SI;
+extern tree size_overflow_type_DI;
+extern tree size_overflow_type_TI;
+
+
+// size_overflow_plugin_hash.c
+struct size_overflow_hash {
+	const struct size_overflow_hash * const next;
+	const char * const name;
+	const char * const context;
+	const unsigned int param;
+};
+
+extern const char *get_orig_decl_name(const_tree decl);
+extern bool is_size_overflow_asm(const_gimple stmt);
+extern void print_missing_function(next_interesting_function_t node);
+extern const struct size_overflow_hash *get_size_overflow_hash_entry_tree(const_tree fndecl, unsigned int argnum, bool hash_table);
+extern unsigned int find_arg_number_tree(const_tree arg, const_tree func);
+extern unsigned int get_decl_hash(const_tree decl, const char *decl_name);
+extern const struct size_overflow_hash *get_size_overflow_hash_entry(unsigned int hash, const char *decl_name, const char *context, unsigned int argnum);
+
+
+// intentional_overflow.c
+extern enum intentional_mark get_intentional_attr_type(const_tree node);
+extern tree get_size_overflow_asm_input(const gasm *stmt);
+extern enum intentional_mark check_intentional_size_overflow_asm_and_attribute(const_tree var);
+extern bool is_size_overflow_insert_check_asm(const gasm *stmt);
+extern enum intentional_mark check_intentional_attribute(const_gimple stmt, unsigned int argnum);
+extern enum intentional_mark get_so_asm_type(const_gimple stmt);
+extern const_tree get_attribute(const char* attr_name, const_tree decl);
+extern bool is_a_cast_and_const_overflow(const_tree no_const_rhs);
+extern bool is_const_plus_unsigned_signed_truncation(const_tree lhs);
+extern bool is_a_constant_overflow(const gassign *stmt, const_tree rhs);
+extern tree handle_intentional_overflow(struct visited *visited, interesting_stmts_t expand_from, bool check_overflow, gassign *stmt, tree change_rhs, tree new_rhs2);
+extern tree handle_integer_truncation(struct visited *visited, interesting_stmts_t expand_from, const_tree lhs);
+extern bool is_a_neg_overflow(const gassign *stmt, const_tree rhs);
+extern enum intentional_overflow_type add_mul_intentional_overflow(const gassign *stmt);
+extern void unsigned_signed_cast_intentional_overflow(struct visited *visited, gassign *stmt);
+extern bool neg_short_add_intentional_overflow(gassign *stmt);
+extern bool is_bitfield_unnamed_cast(const_tree decl, gassign *assign);
+extern bool uconst_neg_intentional_overflow(const gassign *stmt);
+
+
+// insert_size_overflow_asm.c
+#if BUILDING_GCC_VERSION >= 4009
+extern opt_pass *make_insert_size_overflow_asm_pass(void);
+#else
+extern struct opt_pass *make_insert_size_overflow_asm_pass(void);
+#endif
+extern bool search_interesting_args(tree fndecl, bool *argnums);
+
+
+// size_overflow_misc.c
+extern bool is_vararg(const_tree fn, unsigned int num);
+extern tree get_ref_field(const_tree ref);
+extern unsigned int get_correct_argnum_fndecl(const_tree fndecl, const_tree correct_argnum_of_fndecl, unsigned int num);
+extern const char *get_type_name_from_field(const_tree field_decl);
+extern void set_dominance_info(void);
+extern void unset_dominance_info(void);
+extern tree get_interesting_orig_fndecl_from_stmt(const gcall *stmt);
+extern tree get_orig_fndecl(const_tree clone_fndecl);
+extern unsigned int get_correct_argnum(const_tree decl, const_tree correct_argnum_of_decl, unsigned int argnum);
+extern bool is_valid_cgraph_node(struct cgraph_node *node);
+extern void set_current_function_decl(tree fndecl);
+extern void unset_current_function_decl(void);
+extern gimple get_def_stmt(const_tree node);
+extern tree create_new_var(tree type);
+extern gimple build_cast_stmt(struct visited *visited, tree dst_type, tree rhs, tree lhs, gimple_stmt_iterator *gsi, bool before, bool force);
+extern bool skip_types(const_tree var);
+extern tree cast_a_tree(tree type, tree var);
+extern bool is_size_overflow_type(const_tree var);
+extern bool made_by_compiler(const_tree decl);
+extern gimple get_fnptr_def_stmt(const_tree fn_ptr);
+extern tree get_lhs(const_gimple stmt);
+
+
+// size_overflow_transform.c
+struct interesting_stmts {
+	struct interesting_stmts *next;
+	next_interesting_function_t next_node;
+	gimple first_stmt;
+	tree orig_node;
+	unsigned int num;
+};
+
+extern unsigned int size_overflow_function_transform(struct cgraph_node *node);
+extern tree handle_fnptr_assign(const_gimple stmt);
+
+
+// size_overflow_transform_core.c
+extern tree cast_to_new_size_overflow_type(struct visited *visited, gimple stmt, tree rhs, tree size_overflow_type, bool before);
+extern tree get_size_overflow_type(struct visited *visited, const_gimple stmt, const_tree node);
+extern tree expand(struct visited *visited, interesting_stmts_t expand_from, tree lhs);
+extern void check_size_overflow(interesting_stmts_t expand_from, gimple stmt, tree size_overflow_type, tree cast_rhs, tree rhs, bool before);
+extern tree dup_assign(struct visited *visited, gassign *oldstmt, const_tree node, tree rhs1, tree rhs2, tree __unused rhs3);
+extern tree create_assign(struct visited *visited, gimple oldstmt, tree rhs1, bool before);
+
+
+// remove_unnecessary_dup.c
+extern struct opt_pass *make_remove_unnecessary_dup_pass(void);
+extern void insert_cast_expr(struct visited *visited, gassign *stmt, enum intentional_overflow_type type);
+extern bool skip_expr_on_double_type(const gassign *stmt);
+extern void create_up_and_down_cast(struct visited *visited, gassign *use_stmt, tree orig_type, tree rhs);
+
+
+// size_overflow_ipa.c
+struct walk_use_def_data {
+	next_interesting_function_t parent;
+	next_interesting_function_t next_cnodes_head;
+	gimple_set *visited;
+};
+
+extern const char* get_decl_context(const_tree decl);
+extern void add_to_global_next_interesting_function(next_interesting_function_t new_entry);
+extern bool has_next_interesting_function_vec(next_interesting_function_t target, next_interesting_function_t next_node);
+extern void push_child(next_interesting_function_t parent, next_interesting_function_t child);
+extern struct cgraph_node *get_cnode(const_tree fndecl);
+extern next_interesting_function_t global_next_interesting_function[GLOBAL_NIFN_LEN];
+extern next_interesting_function_t get_global_next_interesting_function_entry(struct fn_raw_data *raw_data);
+extern next_interesting_function_t get_global_next_interesting_function_entry_with_hash(struct fn_raw_data *raw_data);
+extern void size_overflow_register_hooks(void);
+#if BUILDING_GCC_VERSION >= 4009
+extern opt_pass *make_size_overflow_pass(void);
+#else
+extern struct opt_pass *make_size_overflow_pass(void);
+#endif
+extern void size_overflow_node_removal_hook(struct cgraph_node *node, void *data);
+extern next_interesting_function_t get_and_create_next_node_from_global_next_nodes(struct fn_raw_data *raw_data, next_interesting_function_t orig_next_node);
+extern next_interesting_function_t create_new_next_interesting_decl(struct fn_raw_data *raw_data, next_interesting_function_t orig_next_node);
+extern next_interesting_function_t create_new_next_interesting_entry(struct fn_raw_data *raw_data, next_interesting_function_t orig_next_node);
+
+
+// size_overflow_lto.c
+extern void size_overflow_read_summary(void);
+extern void size_overflow_read_optimization_summary(void);
+#if BUILDING_GCC_VERSION >= 4008
+extern void size_overflow_write_summary(void);
+extern void size_overflow_write_optimization_summary(void);
+#elif BUILDING_GCC_VERSION >= 4006
+extern void size_overflow_write_summary(cgraph_node_set set, varpool_node_set vset);
+extern void size_overflow_write_optimization_summary(cgraph_node_set set, varpool_node_set vset);
+#else
+extern void size_overflow_write_summary(cgraph_node_set set);
+extern void size_overflow_write_optimization_summary(cgraph_node_set set);
+#endif
+
+// size_overflow_fnptrs.c
+extern void handle_function_ptr_ret(struct walk_use_def_data *use_def_data, const_tree fn_ptr);
+extern void check_local_variables(next_interesting_function_t next_node);
+extern void check_global_variables(next_interesting_function_t cur_global);
+extern next_interesting_function_t get_and_create_next_node_from_global_next_nodes_fnptr(const_tree fn_ptr, struct fn_raw_data *raw_data);
+
+
+// size_overflow_debug.c
+extern void __unused print_intentional_mark(enum intentional_mark mark);
+extern unsigned int __unused size_overflow_dump_function(FILE *file, struct cgraph_node *node);
+extern void __unused print_next_interesting_functions_chain(next_interesting_function_t head, bool only_this);
+extern void __unused print_global_next_interesting_functions(void);
+extern void __unused print_children_chain_list(next_interesting_function_t next_node);
+extern void __unused print_all_next_node_children_chain_list(next_interesting_function_t next_node);
+extern const char * __unused print_so_mark_name(enum size_overflow_mark mark);
+extern const char * __unused print_intentional_mark_name(enum intentional_mark mark);
+
+#endif
diff --git a/tools/gcc/size_overflow_plugin/size_overflow_debug.c b/tools/gcc/size_overflow_plugin/size_overflow_debug.c
new file mode 100644
index 0000000..fc58e16
--- /dev/null
+++ b/tools/gcc/size_overflow_plugin/size_overflow_debug.c
@@ -0,0 +1,194 @@
+/*
+ * Copyright 2011-2015 by Emese Revfy <re.emese@gmail.com>
+ * Licensed under the GPL v2, or (at your option) v3
+ *
+ * Homepage:
+ * https://github.com/ephox-gcc-plugins/size_overflow
+ *
+ * Documentation:
+ * http://forums.grsecurity.net/viewtopic.php?f=7&t=3043
+ *
+ * This plugin recomputes expressions of function arguments marked by a size_overflow attribute
+ * with double integer precision (DImode/TImode for 32/64 bit integer types).
+ * The recomputed argument is checked against TYPE_MAX and an event is logged on overflow and the triggering process is killed.
+ *
+ * Usage:
+ * $ make
+ * $ make run
+ */
+
+#include "size_overflow.h"
+
+void __unused print_intentional_mark(enum intentional_mark mark)
+{
+	fprintf(stderr, "intentional mark: ");
+	switch (mark) {
+	case MARK_NO:
+		fprintf(stderr, "mark_no\n");
+		break;
+	case MARK_YES:
+		fprintf(stderr, "mark_yes\n");
+		break;
+	case MARK_TURN_OFF:
+		fprintf(stderr, "mark_turn_off\n");
+		break;
+	case MARK_END_INTENTIONAL:
+		fprintf(stderr, "mark_end_intentional\n");
+		break;
+	}
+}
+
+unsigned int __unused size_overflow_dump_function(FILE *file, struct cgraph_node *node)
+{
+	basic_block bb;
+
+	fprintf(file, "dump_function function_name: %s\n", cgraph_node_name(node));
+
+	fprintf(file, "\nstmts:\n");
+	FOR_EACH_BB_FN(bb, DECL_STRUCT_FUNCTION(NODE_DECL(node))) {
+		gimple_stmt_iterator si;
+
+		fprintf(file, "<bb %u>:\n", bb->index);
+		for (si = gsi_start_phis(bb); !gsi_end_p(si); gsi_next(&si))
+			print_gimple_stmt(file, gsi_stmt(si), 0, TDF_VOPS|TDF_MEMSYMS);
+		for (si = gsi_start_bb(bb); !gsi_end_p(si); gsi_next(&si))
+			print_gimple_stmt(file, gsi_stmt(si), 0, TDF_VOPS|TDF_MEMSYMS);
+		fprintf(file, "\n");
+	}
+
+	fprintf(file, "---------------------------------\n");
+
+	return 0;
+}
+
+static void __unused print_next_interesting_function(next_interesting_function_t node)
+{
+	unsigned int i, children_len;
+	next_interesting_function_t cur;
+
+	if (!node)
+		return;
+
+#if BUILDING_GCC_VERSION <= 4007
+	if (VEC_empty(next_interesting_function_t, node->children))
+		children_len = 0;
+	else
+		children_len = VEC_length(next_interesting_function_t, node->children);
+#else
+	children_len = vec_safe_length(node->children);
+#endif
+
+	fprintf(stderr, "print_next_interesting_function: ptr: %p, ", node);
+	fprintf(stderr, "decl_name: %s, ", node->decl_name);
+
+	fprintf(stderr, "num: %u marked: %s context: %s children len: %u\n", node->num, print_so_mark_name(node->marked), node->context, children_len);
+#if BUILDING_GCC_VERSION <= 4007
+	if (VEC_empty(next_interesting_function_t, node->children))
+		return;
+	FOR_EACH_VEC_ELT(next_interesting_function_t, node->children, i, cur) {
+#else
+	FOR_EACH_VEC_SAFE_ELT(node->children, i, cur) {
+#endif
+		fprintf(stderr, "\t%u. child: %s %u %p marked: %s context: %s\n", i + 1, cur->decl_name, cur->num, cur, print_so_mark_name(cur->marked), cur->context);
+	}
+}
+
+// Dump the full next_interesting_function_t list for parsing by print_dependecy.py
+void __unused print_next_interesting_functions_chain(next_interesting_function_t head, bool only_this)
+{
+	next_interesting_function_t cur;
+	unsigned int len;
+
+	fprintf(stderr, "----------------------\nnext_interesting_function_t head: %p\n", head);
+	for (cur = head, len = 0; cur; cur = cur->next, len++) {
+		fprintf(stderr, "%u. ", len + 1);
+		print_next_interesting_function(cur);
+
+		fprintf(stderr, "+++++ has orig node: %p +++++\n", cur->orig_next_node);
+		print_next_interesting_function(cur->orig_next_node);
+
+		if (only_this)
+			break;
+	}
+
+	fprintf(stderr, "len: %u\n----------------------\n\n\n", len + 1);
+}
+
+void __unused print_global_next_interesting_functions(void)
+{
+	unsigned int i;
+
+	fprintf(stderr, "----------------------\nprint_global_next_interesting_functions:\n----------------------\n");
+	for (i = 0; i < GLOBAL_NIFN_LEN; i++) {
+		if (!global_next_interesting_function[i])
+			continue;
+		fprintf(stderr, "hash: %u\n", i);
+		print_next_interesting_functions_chain(global_next_interesting_function[i], false);
+	}
+	fprintf(stderr, "----------------------\n\n");
+}
+
+// Dump the information related to the specified next_interesting_function_t for parsing by print_dependecy.py
+void __unused print_children_chain_list(next_interesting_function_t next_node)
+{
+	next_interesting_function_t cur;
+	unsigned int i;
+
+#if BUILDING_GCC_VERSION <= 4007
+	if (VEC_empty(next_interesting_function_t, next_node->children))
+		return;
+	FOR_EACH_VEC_ELT(next_interesting_function_t, next_node->children, i, cur) {
+#else
+	FOR_EACH_VEC_SAFE_ELT(next_node->children, i, cur) {
+#endif
+		fprintf(stderr, "parent: %s %u (marked: %s) child: %s %u\n", next_node->decl_name, next_node->num, print_so_mark_name(next_node->marked), cur->decl_name, cur->num);
+		print_children_chain_list(cur);
+	}
+}
+
+void __unused print_all_next_node_children_chain_list(next_interesting_function_t head)
+{
+	next_interesting_function_t cur;
+
+	for (cur = head; cur; cur = cur->next) {
+#if BUILDING_GCC_VERSION <= 4007
+		if (VEC_empty(next_interesting_function_t, cur->children))
+#else
+		if (vec_safe_length(cur->children) == 0)
+#endif
+			continue;
+		fprintf(stderr, "############ START ############\n");
+		print_children_chain_list(cur);
+		fprintf(stderr, "############ END ############\n");
+	}
+}
+
+const char * __unused print_intentional_mark_name(enum intentional_mark mark)
+{
+	switch(mark) {
+	case MARK_NO:
+		return "mark no";
+	case MARK_YES:
+		return "mark yes";
+	case MARK_END_INTENTIONAL:
+		return "mark end intetional";
+	case MARK_TURN_OFF:
+		return "mark turn off";
+	}
+
+	gcc_unreachable();
+}
+
+const char * __unused print_so_mark_name(enum size_overflow_mark mark)
+{
+	switch(mark) {
+	case ASM_STMT_SO_MARK:
+		return "asm_stmt_so_mark";
+	case YES_SO_MARK:
+		return "yes_so_mark";
+	case NO_SO_MARK:
+		return "no_so_mark";
+	}
+
+	gcc_unreachable();
+}
diff --git a/tools/gcc/size_overflow_plugin/size_overflow_hash_aux.data b/tools/gcc/size_overflow_plugin/size_overflow_hash_aux.data
new file mode 100644
index 0000000..17bc0d8
--- /dev/null
+++ b/tools/gcc/size_overflow_plugin/size_overflow_hash_aux.data
@@ -0,0 +1,92 @@
+enable_so_spa_set_aux_vdevs_fndecl_746 spa_set_aux_vdevs fndecl 3 746 NULL
+enable_so_zfs_lookup_fndecl_2144 zfs_lookup fndecl 0 2144 NULL
+enable_so_mappedread_fndecl_2627 mappedread fndecl 2 2627 NULL
+enable_so_vdev_disk_dio_alloc_fndecl_2957 vdev_disk_dio_alloc fndecl 1 2957 NULL
+enable_so_nv_alloc_pushpage_spl_fndecl_4286 nv_alloc_pushpage_spl fndecl 2 4286 NULL
+enable_so_zpl_xattr_get_fndecl_4574 zpl_xattr_get fndecl 0 4574 NULL
+enable_so_sa_replace_all_by_template_fndecl_5699 sa_replace_all_by_template fndecl 3 5699 NULL
+enable_so_dmu_write_fndecl_6048 dmu_write fndecl 4-3 6048 NULL
+enable_so_dmu_buf_hold_array_fndecl_6095 dmu_buf_hold_array fndecl 4-3 6095 NULL
+enable_so_update_pages_fndecl_6225 update_pages fndecl 2-3 6225 NULL
+enable_so_bio_nr_pages_fndecl_7117 bio_nr_pages fndecl 0-2 7117 NULL
+enable_so_dmu_buf_hold_array_by_bonus_fndecl_8562 dmu_buf_hold_array_by_bonus fndecl 3-2 8562 NULL
+enable_so_zpios_dmu_write_fndecl_8858 zpios_dmu_write fndecl 4-5 8858 NULL
+enable_so_ddi_copyout_fndecl_9401 ddi_copyout fndecl 3 9401 NULL
+enable_so_avl_numnodes_fndecl_12384 avl_numnodes fndecl 0 12384 NULL
+enable_so_dmu_write_uio_dnode_fndecl_12473 dmu_write_uio_dnode fndecl 3 12473 NULL
+enable_so_dmu_xuio_init_fndecl_12866 dmu_xuio_init fndecl 2 12866 NULL
+enable_so_zpl_read_common_fndecl_14389 zpl_read_common fndecl 0 14389 NULL
+enable_so_dmu_snapshot_realname_fndecl_14632 dmu_snapshot_realname fndecl 4 14632 NULL
+enable_so_kmem_alloc_debug_fndecl_14852 kmem_alloc_debug fndecl 1 14852 NULL
+enable_so_kmalloc_node_nofail_fndecl_15151 kmalloc_node_nofail fndecl 1 15151 NULL
+enable_so_dmu_write_uio_fndecl_16351 dmu_write_uio fndecl 4 16351 NULL
+enable_so_zfs_log_write_fndecl_16524 zfs_log_write fndecl 6-5 16524 NULL
+enable_so_sa_build_layouts_fndecl_16910 sa_build_layouts fndecl 3 16910 NULL
+enable_so_dsl_dir_namelen_fndecl_17053 dsl_dir_namelen fndecl 0 17053 NULL
+enable_so_kcopy_copy_to_user_fndecl_17336 kcopy_copy_to_user fndecl 5 17336 NULL
+enable_so_sa_add_layout_entry_fndecl_17507 sa_add_layout_entry fndecl 3 17507 NULL
+enable_so_sa_attr_table_setup_fndecl_18029 sa_attr_table_setup fndecl 3 18029 NULL
+enable_so_uiocopy_fndecl_18680 uiocopy fndecl 2 18680 NULL
+enable_so_dmu_buf_hold_array_by_dnode_fndecl_19125 dmu_buf_hold_array_by_dnode fndecl 2-3 19125 NULL
+enable_so_zpl_acl_from_xattr_fndecl_21141 zpl_acl_from_xattr fndecl 2 21141 NULL
+enable_so_dsl_pool_tx_assign_init_fndecl_22518 dsl_pool_tx_assign_init fndecl 2 22518 NULL
+enable_so_nvlist_lookup_byte_array_fndecl_22527 nvlist_lookup_byte_array fndecl 0 22527 NULL
+enable_so_sa_replace_all_by_template_locked_fndecl_22533 sa_replace_all_by_template_locked fndecl 3 22533 NULL
+enable_so_tsd_hash_table_init_fndecl_22559 tsd_hash_table_init fndecl 1 22559 NULL
+enable_so_spa_vdev_remove_aux_fndecl_23966 spa_vdev_remove_aux fndecl 4 23966 NULL
+enable_so_zpl_xattr_acl_set_access_fndecl_24129 zpl_xattr_acl_set_access fndecl 4 24129 NULL
+enable_so_dmu_assign_arcbuf_fndecl_24622 dmu_assign_arcbuf fndecl 2 24622 NULL
+enable_so_zap_lookup_norm_fndecl_25166 zap_lookup_norm fndecl 9 25166 NULL
+enable_so_dmu_prealloc_fndecl_25456 dmu_prealloc fndecl 4-3 25456 NULL
+enable_so_kmalloc_nofail_fndecl_26347 kmalloc_nofail fndecl 1 26347 NULL
+enable_so_zfsctl_snapshot_zpath_fndecl_27578 zfsctl_snapshot_zpath fndecl 2 27578 NULL
+enable_so_zpios_dmu_read_fndecl_30015 zpios_dmu_read fndecl 4-5 30015 NULL
+enable_so_splat_write_fndecl_30943 splat_write fndecl 3 30943 NULL
+enable_so_zpl_xattr_get_sa_fndecl_31183 zpl_xattr_get_sa fndecl 0 31183 NULL
+enable_so_dmu_read_uio_fndecl_31467 dmu_read_uio fndecl 4 31467 NULL
+enable_so_zfs_replay_fuids_fndecl_31479 zfs_replay_fuids fndecl 4 31479 NULL
+enable_so_spa_history_log_to_phys_fndecl_31632 spa_history_log_to_phys fndecl 0-1 31632 NULL
+enable_so___zpl_xattr_get_fndecl_32601 __zpl_xattr_get fndecl 0 32601 NULL
+enable_so_proc_copyout_string_fndecl_34049 proc_copyout_string fndecl 2 34049 NULL
+enable_so_nv_alloc_sleep_spl_fndecl_34544 nv_alloc_sleep_spl fndecl 2 34544 NULL
+enable_so_nv_alloc_nosleep_spl_fndecl_34761 nv_alloc_nosleep_spl fndecl 2 34761 NULL
+enable_so_zap_leaf_array_match_fndecl_36922 zap_leaf_array_match fndecl 4 36922 NULL
+enable_so_copyinstr_fndecl_36980 copyinstr fndecl 3 36980 NULL
+enable_so_zpl_xattr_acl_set_default_fndecl_37864 zpl_xattr_acl_set_default fndecl 4 37864 NULL
+enable_so_splat_read_fndecl_38116 splat_read fndecl 3 38116 NULL
+enable_so_sa_setup_fndecl_38756 sa_setup fndecl 4 38756 NULL
+enable_so_vdev_disk_physio_fndecl_39898 vdev_disk_physio fndecl 3 39898 NULL
+enable_so_arc_buf_size_fndecl_39982 arc_buf_size fndecl 0 39982 NULL
+enable_so_kzalloc_nofail_fndecl_40719 kzalloc_nofail fndecl 1 40719 NULL
+enable_so_fuidstr_to_sid_fndecl_40777 fuidstr_to_sid fndecl 4 40777 NULL
+enable_so_vdev_raidz_matrix_reconstruct_fndecl_40852 vdev_raidz_matrix_reconstruct fndecl 2-3 40852 NULL
+enable_so_sa_find_layout_fndecl_40892 sa_find_layout fndecl 4 40892 NULL
+enable_so_zpl_xattr_get_dir_fndecl_41918 zpl_xattr_get_dir fndecl 0 41918 NULL
+enable_so_zfs_sa_get_xattr_fndecl_42600 zfs_sa_get_xattr fndecl 0 42600 NULL
+enable_so_zpl_xattr_acl_set_fndecl_42808 zpl_xattr_acl_set fndecl 4 42808 NULL
+enable_so_xdr_dec_array_fndecl_43091 xdr_dec_array fndecl 5 43091 NULL
+enable_so_dsl_dataset_namelen_fndecl_43136 dsl_dataset_namelen fndecl 0 43136 NULL
+enable_so_kcopy_write_fndecl_43683 kcopy_write fndecl 3 43683 NULL
+enable_so_uiomove_fndecl_44355 uiomove fndecl 2 44355 NULL
+enable_so_dmu_read_fndecl_44418 dmu_read fndecl 4-3 44418 NULL
+enable_so_ddi_copyin_fndecl_44846 ddi_copyin fndecl 3 44846 NULL
+enable_so_kcopy_do_get_fndecl_45061 kcopy_do_get fndecl 5 45061 NULL
+enable_so_copyin_fndecl_45945 copyin fndecl 3 45945 NULL
+enable_so_zil_itx_create_fndecl_46555 zil_itx_create fndecl 2 46555 NULL
+enable_so_dmu_write_uio_dbuf_fndecl_48064 dmu_write_uio_dbuf fndecl 3 48064 NULL
+enable_so_blk_rq_pos_fndecl_48233 blk_rq_pos fndecl 0 48233 NULL
+enable_so_spa_history_write_fndecl_49650 spa_history_write fndecl 3 49650 NULL
+enable_so_kcopy_copy_pages_to_user_fndecl_49823 kcopy_copy_pages_to_user fndecl 3-4 49823 NULL
+enable_so_zfs_log_write_fndecl_50162 zfs_log_write fndecl 6-5 50162 NULL
+enable_so_i_fm_alloc_fndecl_51038 i_fm_alloc fndecl 2 51038 NULL
+enable_so_copyout_fndecl_51409 copyout fndecl 3 51409 NULL
+enable_so_zvol_log_write_fndecl_54898 zvol_log_write fndecl 4-3 54898 NULL
+enable_so_zfs_acl_node_alloc_fndecl_55641 zfs_acl_node_alloc fndecl 1 55641 NULL
+enable_so_get_nvlist_fndecl_56685 get_nvlist fndecl 2 56685 NULL
+enable_so_zprop_get_numprops_fndecl_56820 zprop_get_numprops fndecl 0 56820 NULL
+enable_so_splat_taskq_test4_common_fndecl_59829 splat_taskq_test4_common fndecl 5 59829 NULL
+enable_so_zfs_replay_domain_cnt_fndecl_61399 zfs_replay_domain_cnt fndecl 0 61399 NULL
+enable_so_zpios_write_fndecl_61823 zpios_write fndecl 3 61823 NULL
+enable_so_proc_copyin_string_fndecl_62019 proc_copyin_string fndecl 4 62019 NULL
+enable_so_random_get_pseudo_bytes_fndecl_64611 random_get_pseudo_bytes fndecl 2 64611 NULL
+enable_so_zpios_read_fndecl_64734 zpios_read fndecl 3 64734 NULL
